            #GIT_CMT=0b023dd510e7a03346579ca587c47b97969ea245
%define uek2epoch 2
%define uek4epoch 4
%define uek5epoch 5

%global flavor ora

# Do not build static libs by default.
%define with_static %{?_with_static: 1} %{?!_with_static: 0}

# Build pyverbs by default for both OL7 and OL8
%define with_pyverbs %{?_with_pyverbs: 1} %{?!_with_pyverbs: %{?!_without_pyverbs: 1} %{?_without_pyverbs: 0}}

# When we add the pyverbs-based tests on OL7 in a path that does not contain
# 'pythonX.Y' the brp-python-bytecompile macro does not pick the correct
# python interpreter so make it use python3
%if 0%{?rhel} == 7 && %{with_pyverbs}
%global __python %{__python3}
%endif

# Orabug: 29839092 - To produce unstripped binaries for Exadata we disable the
# creation of the -debuginfo package.
%define debug_package %{nil}

%define         git_hash %{nil}
Name:           rdma-core
Epoch:          %{uek5epoch}
Version:        34.0
Release:        1.0.8%{?dist}%{?flavor}
Summary:        RDMA core userspace libraries and daemons
License:        GPL-2.0 or BSD-2-Clause

# Almost everything is licensed under the OFA dual GPLv2, 2 Clause BSD license
#  providers/ipathverbs/ Dual licensed using a BSD license with an extra patent clause
#  providers/rxe/ Incorporates code from ipathverbs and contains the patent clause
#  providers/hfi1verbs Uses the 3 Clause BSD license
Url:            https://github.com/linux-rdma/rdma-core
Source: rdma-core-34.0.tar.bz2

BuildRequires:  binutils
BuildRequires:  cmake3
BuildRequires:  gcc
# pandoc is not supported in OL9. OL9 will use the prebuilt man pages
%if 0%{?rhel} < 9
BuildRequires:  pandoc
%endif
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(libnl-3.0)
BuildRequires:  pkgconfig(libnl-route-3.0)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(systemd)

# Both OL7 & OL8 may use python3 for building packages
BuildRequires: python3

# Oracle's build environment requires python3-devel for OL7
# or cmake3 will not find python.
%if 0%{?rhel} == 7 || %{with_pyverbs}
BuildRequires: python3-devel
%endif

%if %{with_pyverbs}
%if 0%{?rhel} >= 8
BuildRequires: python3-Cython
%else
BuildRequires: python36-Cython
%endif
%endif

%if 0%{?rhel} >= 8
BuildRequires: python3-docutils
%else
BuildRequires: python-docutils
%endif

%if 0%{?rhel} >=8
BuildRequires: perl-generators
%endif

BuildRequires:  sed
BuildRequires:  valgrind-devel

Requires:       pciutils

%if 0%{?rhel} >= 8
Requires:       systemd-udev
%else
Requires:       systemd
%endif

# Oracle previously shipped oracle/ as a stand-alone
# package called 'rdma', which we're supplanting here.
Provides:       rdma = %{epoch}:%{version}-%{release}
Obsoletes:      rdma < %{epoch}:%{version}-%{release}

# the rdma-ndd utility moved from infiniband-diags to rdma-core
Conflicts:      infiniband-diags <= 1.6.7
Provides:       rdma-ndd = %{epoch}:%{version}-%{release}
Obsoletes:      rdma-ndd < %{epoch}:%{version}-%{release}

# ibdev2netdev moved from oracle-rdma-tools to rdma-core
Conflicts:      oracle-rdma-tools < 0.11.0
Provides:       ibdev2netdev = %{epoch}:%{version}-%{release}
Obsoletes:      ibdev2netdev < %{epoch}:%{version}-%{release}
Provides:       show_gids = %{epoch}:%{version}-%{release}
Obsoletes:      show_gids < %{epoch}:%{version}-%{release}

# Since we recommend developers use Ninja, so should packagers, for consistency.
#  Oracle Linux 7 does not ship Ninja so the build system must be configured to
#  enable the EPEL repo.
BuildRequires:  ninja-build
%define CMAKE_FLAGS -GNinja
%if 0%{?rhel} >= 9
%define make_jobs ninja-build -C %{_vpath_builddir} -v %{?_smp_mflags}
%define cmake_install DESTDIR=%{buildroot} ninja-build -C %{_vpath_builddir} install
%else
%define make_jobs ninja-build -v %{?_smp_mflags}
%define cmake_install DESTDIR=%{buildroot} ninja-build install
%endif

%description
RDMA core userspace infrastructure and documentation, including initialization
scripts, kernel driver-specific modprobe override configs, IPoIB network scripts,
dracut rules, and the rdma-ndd utility.

%package        devel
Summary:        RDMA core development libraries and headers

Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}
Provides:       libibverbs-devel = %{epoch}:%{version}-%{release}
Obsoletes:      libibverbs-devel < %{epoch}:%{version}-%{release}
Provides:       libibverbs-devel-static = %{epoch}:%{version}-%{release}
Obsoletes:      libibverbs-devel-static < %{epoch}:%{version}-%{release}

Requires:       libibumad%{?_isa} = %{epoch}:%{version}-%{release}
Provides:       libibumad-devel = %{epoch}:%{version}-%{release}
Obsoletes:      libibumad-devel < %{epoch}:%{version}-%{release}
Provides:       libibumad-static = %{epoch}:%{version}-%{release}
Obsoletes:      libibumad-static < %{epoch}:%{version}-%{release}

Requires:       librdmacm%{?_isa} = %{epoch}:%{version}-%{release}
Provides:       librdmacm-devel = %{epoch}:%{version}-%{release}
Obsoletes:      librdmacm-devel < %{epoch}:%{version}-%{release}
Provides:       librdmacm-static = %{epoch}:%{version}-%{release}
Obsoletes:      librdmacm-static < %{epoch}:%{version}-%{release}

Requires:       ibacm%{?_isa} = %{epoch}:%{version}-%{release}
Provides:       ibacm-devel = %{epoch}:%{version}-%{release}
Obsoletes:      ibacm-devel < %{epoch}:%{version}-%{release}

Requires:       infiniband-diags%{?_isa} = %{epoch}:%{version}-%{release}
Provides:       infiniband-diags-devel = %{epoch}:%{version}-%{release}
Obsoletes:      infiniband-diags-devel < %{epoch}:%{version}-%{release}

Provides:       libibmad-devel = %{epoch}:%{version}-%{release}
Obsoletes:      libibmad-devel < %{epoch}:%{version}-%{release}

Provides:       libmlx4-static = %{epoch}:%{version}-%{release}
Obsoletes:      libmlx4-static < %{epoch}:%{version}-%{release}

Provides:       libmlx5-static = %{epoch}:%{version}-%{release}
Obsoletes:      libmlx5-static < %{epoch}:%{version}-%{release}

%if %{with_static}
# Since our pkg-config files include private references to these packages they
# need to have their .pc files installed too, even for dynamic linking, or
# pkg-config breaks.
BuildRequires: pkgconfig(libnl-3.0)
BuildRequires: pkgconfig(libnl-route-3.0)
%endif

%description devel
RDMA core development libraries and headers.

%package -n     ibacm
Summary:        InfiniBand Communication Manager Assistant
Requires:       %{name}%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       libibumad%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}
%{?systemd_requires}

%description -n ibacm
The ibacm daemon helps reduce the load of managing path record lookups on
large InfiniBand fabrics by providing a user space implementation of what
is functionally similar to an ARP cache.  The use of ibacm, when properly
configured, can reduce the SA packet load of a large IB cluster from O(n^2)
to O(n).  The ibacm daemon is started and normally runs in the background,
user applications need not know about this daemon as long as their app
uses librdmacm to handle connection bring up/tear down.  The librdmacm
library knows how to talk directly to the ibacm daemon to retrieve data.

%package -n     infiniband-diags
Summary:        InfiniBand Diagnostic Tools
Requires:       perl
Provides:       perl(IBswcountlimits)
Provides:       libibmad = %{epoch}:%{version}-%{release}
Obsoletes:      libibmad < %{epoch}:%{version}-%{release}
Obsoletes:      openib-diags < 1.3
Conflicts:      infiniband-diags-guest

%description -n infiniband-diags
This package provides IB diagnostic programs and scripts needed to diagnose an
IB subnet.  infiniband-diags now also provides libibmad.  libibmad provides
low layer IB functions for use by the IB diagnostic and management
programs. These include MAD, SA, SMP, and other basic IB functions.

%package -n     infiniband-diags-compat
Summary:        OpenFabrics Alliance InfiniBand Diagnostic Tools

%description -n infiniband-diags-compat
Deprecated scripts and utilities which provide duplicated functionality, most
often at a reduced performance. These are maintained for the time being for
compatibility reasons.

%package -n     infiniband-diags-guest
Summary:        InfiniBand Diagnostic Tools for Virtual Machines
Requires:       perl
Provides:       perl(IBswcountlimits)
Provides:       libibmad = %{epoch}:%{version}-%{release}
Obsoletes:      libibmad < %{epoch}:%{version}-%{release}
Obsoletes:      openib-diags < 1.3
Conflicts:      infiniband-diags

%description -n infiniband-diags-guest
This package provides IB diagnostic programs and scripts needed for Virtual
Machines to diagnose an IB subnet. infiniband-diags-guest now also provides
libibmad. libibmad provides low layer IB functions for use by the IB diagnostic
and management programs. These include MAD, SA, SMP, and other basic IB functions.

%package -n     iwpmd
Summary:        iWarp Port Mapper userspace daemon
Requires:       %{name}%{?_isa} = %{epoch}:%{version}-%{release}
%{?systemd_requires}

%description -n iwpmd
iwpmd provides a userspace service for iWarp drivers to claim
tcp ports through the standard socket interface.

%package -n     libibumad
Summary:        OpenFabrics Alliance InfiniBand umad (userspace management datagram) library

%description -n libibumad
libibumad provides the userspace management datagram (umad) library
functions, which sit on top of the umad modules in the kernel. These
are used by the IB diagnostic and management tools, including OpenSM.

%package -n     libibverbs
Summary:        A library and drivers for direct userspace use of RDMA (InfiniBand/iWARP/RoCE) hardware

Provides:       libmlx4 = %{epoch}:%{version}-%{release}
Obsoletes:      libmlx4 < %{epoch}:%{version}-%{release}

Provides:       libmlx5 = %{epoch}:%{version}-%{release}
Obsoletes:      libmlx5 < %{epoch}:%{version}-%{release}

Provides:       librxe = %{epoch}:%{version}-%{release}
Obsoletes:      librxe < %{epoch}:%{version}-%{release}

%description -n libibverbs
libibverbs is a library that allows userspace processes to use RDMA
"verbs" as described in the InfiniBand Architecture Specification and
the RDMA Protocol Verbs Specification.  This includes direct hardware
access from userspace to InfiniBand/iWARP adapters (kernel bypass) for
fast path operations.

Device-specific plug-in ibverbs userspace drivers are included:

- libbxnt_re: Broadcom NetXtreme-E RoCE HCA
- libmlx4: Mellanox ConnectX-3 InfiniBand HCA
- libmlx5: Mellanox Connect-IB/X-4+ InfiniBand HCA
- libqedr: QLogic QL4xxx RoCE HCA
- librxe: A software implementation of the RoCE protocol
- libvmw_pvrdma: VMware paravirtual RDMA device

%package -n     libibverbs-utils
Summary:        Examples for the libibverbs library
Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}

%description -n libibverbs-utils
Useful libibverbs example programs such as ibv_devinfo, which
displays information about RDMA devices.

%package -n     librdmacm
Summary:        Userspace RDMA Connection Manager
Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}

%description -n librdmacm
librdmacm provides a userspace RDMA Communication Management API.

%package -n     librdmacm-utils
Summary:        Examples for the librdmacm library
Requires:       librdmacm%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}

%description -n librdmacm-utils
Example test programs for the librdmacm library.

%if %{with_pyverbs}
%package -n python3-pyverbs
Summary: Python3 API over IB verbs
%{?python_provide:%python_provide python3-pyverbs}

%description -n python3-pyverbs
Pyverbs is a Cython-based Python API over libibverbs, providing an
easy, object-oriented access to IB verbs.

%endif

%package -n     srp_daemon
Summary:        Tools for using the InfiniBand SRP protocol devices
Requires:       %{name}%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       libibumad%{?_isa} = %{epoch}:%{version}-%{release}
Requires:       libibverbs%{?_isa} = %{epoch}:%{version}-%{release}
%{?systemd_requires}

Provides:       srptools = %{epoch}:%{version}-%{release}
Obsoletes:      srptools <= 1.0.3
Obsoletes:      openib-srptools <= 0.0.6

%description -n srp_daemon
In conjunction with the kernel ib_srp driver, srp_daemon allows you to
discover and use SCSI devices via the SCSI RDMA Protocol over InfiniBand.

%prep
%setup -q -n  %{name}-%{version}%{git_hash}

%build
# Disable LTO
#  This package uses top level ASM constructs which are incompatible with
#  LTO. Top level ASMs are often used to implement symbol versioning.
#  gcc-10 introduces a new mechanism for symbol versioning which works with
#  LTO. Converting packages to use that mechanism instead of toplevel ASMs
#  is recommended.
%define _lto_cflags %{nil}

# New RPM defines _rundir, usually as /run
%if 0%{?_rundir:1}
%else
%define _rundir /var/run
%endif

%{!?EXTRA_CMAKE_FLAGS: %define EXTRA_CMAKE_FLAGS %{nil}}

# Pass all of the rpm paths directly to GNUInstallDirs and our other defines.
%cmake3 %{CMAKE_FLAGS} \
         -DCMAKE_BUILD_TYPE=Release \
         -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \
         -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \
         -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \
         -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \
         -DCMAKE_INSTALL_LOCALSTATEDIR:PATH=%{_localstatedir} \
         -DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=%{_sharedstatedir} \
         -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \
         -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \
         -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \
         -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \
         -DCMAKE_INSTALL_SYSTEMD_SERVICEDIR:PATH=%{_unitdir} \
         -DCMAKE_INSTALL_INITDDIR:PATH=%{_initrddir} \
         -DCMAKE_INSTALL_RUNDIR:PATH=%{_rundir} \
         -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir}/%{name} \
         -DCMAKE_INSTALL_UDEV_RULESDIR:PATH=%{_udevrulesdir} \
         -DCMAKE_INSTALL_PERLDIR:PATH=%{perl_vendorlib} \
         -DENABLE_IBDIAGS_COMPAT:BOOL=True \
%if %{with_static}
         -DENABLE_STATIC=1 \
%endif
         %{EXTRA_CMAKE_FLAGS} \
%if %{defined __python3}
         -DPYTHON_EXECUTABLE:PATH=%{__python3} \
         -DCMAKE_INSTALL_PYTHON_ARCH_LIB:PATH=%{python3_sitearch} \
%endif
%if %{with_pyverbs}
         -DNO_PYVERBS=0 \
%else
         -DNO_PYVERBS=1 \
%endif
%if 0%{?rhel} >= 8
	-DINSTALL_RDMAIP_MODULE_LOADER=1\
%else
	-DINSTALL_RDMAIP_MODULE_LOADER=0\
%endif
         -S .
%make_jobs

%install
%cmake_install

mkdir -p %{buildroot}%{_sysconfdir}/rdma

# Make rpmlint happy. On OL, _lib is lib64 so _libdir resolves to /usr/lib64 and
# there is no macro for /usr/lib which is where dracut and modrprobe.d live.
%global oldlib lib
%global dracutlibdir %{_prefix}/%{oldlib}/dracut
%global sysmodprobedir %{_prefix}/%{oldlib}/modprobe.d

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/network-scripts
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
mkdir -p %{buildroot}%{_libexecdir}
mkdir -p %{buildroot}%{_udevrulesdir}
mkdir -p %{buildroot}%{dracutlibdir}/modules.d/05rdma
mkdir -p %{buildroot}%{sysmodprobedir}
mkdir -p %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_sysconfdir}/sysctl.d

# Orabug 33946678 - IPoIB: We need to configure IPoIB interfaces.
# Unconditionally include network-scripts/if{up,down}-ib on OL7, OL8 & OL9,
# until NetworkManager supports pkey-ed IB interfaces with custom names
# (Ex: stibX, clibX on Exadata).
install -D -m0755 oracle/rdma.ifdown-ib %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifdown-ib
install -D -m0755 oracle/rdma.ifup-ib %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifup-ib

# Port type setup for mlx4 dual-port cards
install -D -m0644 oracle/rdma.mlx4.conf %{buildroot}%{_sysconfdir}/rdma/mlx4.conf
install -D -m0644 oracle/rdma.mlx4.sys.modprobe %{buildroot}%{sysmodprobedir}/libmlx4.conf
install -D -m0755 oracle/rdma.mlx4-setup.sh %{buildroot}%{_libexecdir}/mlx4-setup.sh

install -D -m0755 oracle/ibdev2netdev.sh %{buildroot}%{_bindir}/ibdev2netdev
install -D -m0755 oracle/show_gids.sh %{buildroot}%{_bindir}/show_gids

# Configure static GUIDs for mlx4 IOV devices
install -D -m0755 oracle/rdma.mlx4-set-guid.sh %{buildroot}%{_libexecdir}/mlx4-set-guid.sh

# Dracut file for RDMA support during boot
install -D -m0755 oracle/rdma.modules-setup.sh %{buildroot}%{dracutlibdir}/modules.d/05rdma/module-setup.sh

# Orabug: 31377510 - Remove unsupported systemd options from 
# srp_daemon service configuration files for OL7
%if 0%{?rhel} == 7
%define _delete_systemd_opts '/^MemoryDenyWriteExecute=\\|^ProtectControlGroups=\\|^ProtectKernelModules=\\|^RestrictRealtime=/d'
sed -i -e %{_delete_systemd_opts} %{buildroot}%{_unitdir}/srp_daemon.service
sed -i -e %{_delete_systemd_opts} %{buildroot}%{_unitdir}/srp_daemon_port@.service
%endif

#
# Oracle Virtual OS (VOS) configuration
#

# Load RDS: Remove upstream /etc/rdma/modules/rdma.conf and replace with our own
rm -f %{buildroot}%{_sysconfdir}/rdma/modules/rdma.conf
%if 0%{?rhel} >= 8
sed -i -e '/^# Resilient RDMA IP for active bonding/d' oracle/modules.rdma-conf
sed -i -e '/^resilient_rdmaip/d' oracle/modules.rdma-conf
%endif
install -D -m0644 oracle/modules.rdma-conf %{buildroot}%{_sysconfdir}/rdma/modules/rdma.conf
%if 0%{?rhel} >= 8
install -D -m0644 oracle/modules.rdmaip-conf %{buildroot}%{_sysconfdir}/rdma/modules/rdmaip.conf
%endif

# Kernel tuning for RDS: udev rules to load net.rds sysctl settings when RDS modules are plugged
install -D -m0644 oracle/sysctl.rds-rules %{buildroot}%{_sysconfdir}/udev/rules.d/99-rds-sysctl-parameters.rules
install -D -m0644 oracle/sysctl.rds-conf %{buildroot}%{_sysconfdir}/sysctl.d/90-rds.conf

# END Oracle Virtual OS (VOS) configuration

# ibacm
(if [ -d %{__cmake_builddir} ]; then cd %{__cmake_builddir}; fi
./bin/ib_acme -D . -O &&
sed -i -e 's|%{_libdir}|/usr/lib|' %{buildroot}%{_mandir}/man7/ibacm_prov.7 &&
sed -i -e 's|%{_libdir}|/usr/lib|' ibacm_opts.cfg &&
install -D -m0644 ibacm_opts.cfg %{buildroot}%{_sysconfdir}/rdma/)

# Delete the packages' init.d scripts
rm -rf %{buildroot}%{_initrddir}/
rm -f %{buildroot}%{_sbindir}/srp_daemon.sh

# Remove ibverbs provider libs we don't support
rm -f %{buildroot}%{_libdir}/libibverbs/libcxgb3-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/cxgb3.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libcxgb4-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/cxgb4.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libhfi1verbs-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/hfi1verbs.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libhns-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/hns.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libi40iw-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/i40iw.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libipathverbs-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/ipathverbs.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libmthca-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/mthca.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libnes-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/nes.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libocrdma-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/ocrdma.driver
rm -f %{buildroot}%{_libdir}/libibverbs/libsiw-rdmav*.so
rm -f %{buildroot}%{_sysconfdir}/libibverbs.d/siw.driver
find %{buildroot} -type f \( -name '*efa*' ! -name 'mlx5dv*' \) -exec rm -fv {} \;
find %{buildroot} -xtype l \( -name '*efa*' ! -name 'mlx5dv*' \) -exec rm -fv {} \;
if [ -d %{buildroot}%{python3_sitearch}/pyverbs/providers/efa ]; then
rmdir %{buildroot}%{python3_sitearch}/pyverbs/providers/efa
fi

# Our build environment contains Cython and this will cause cmake to
# install pyverbs and pyverbs-based tests files in the buildroot
# even though we are not building pyverbs itself
%if !%{with_pyverbs}
rm -rf %{buildroot}%{python3_sitearch}/
rm -rf %{buildroot}%{_docdir}/%{name}/tests/
%endif

# Retain the old behavior for naming RDMA interfaces
%define _change_naming_mode 's|"rdma_rename %k NAME_FALLBACK"|"rdma_rename %k NAME_KERNEL"|g' 
sed -i -e %{_change_naming_mode} %{buildroot}%{_udevrulesdir}/60-rdma-persistent-naming.rules

%post -n rdma-core
# We ship udev rules, so trigger an update.
if [ -x /sbin/udevadm ]; then
/sbin/udevadm trigger --subsystem-match=infiniband --action=change || true
/sbin/udevadm trigger --subsystem-match=net --action=change || true
/sbin/udevadm trigger --subsystem-match=infiniband_mad --action=change || true
fi

%post -n ibacm
%systemd_post ibacm.service
%preun -n ibacm
%systemd_preun ibacm.service
%postun -n ibacm
%systemd_postun_with_restart ibacm.service

%post -n infiniband-diags -p /sbin/ldconfig
%postun -n infiniband-diags -p /sbin/ldconfig

%post -n iwpmd
%systemd_post iwpmd.service
%preun -n iwpmd
%systemd_preun iwpmd.service
%postun -n iwpmd
%systemd_postun_with_restart iwpmd.service

%post -n libibumad -p /sbin/ldconfig
%postun -n libibumad -p /sbin/ldconfig

%post -n libibverbs -p /sbin/ldconfig
%postun -n libibverbs -p /sbin/ldconfig

%post -n librdmacm -p /sbin/ldconfig
%postun -n librdmacm -p /sbin/ldconfig

%post -n srp_daemon
%systemd_post srp_daemon.service
%preun -n srp_daemon
%systemd_preun srp_daemon.service
%postun -n srp_daemon
%systemd_postun_with_restart srp_daemon.service

%files
%defattr(-,root,root)
%dir %{_sysconfdir}/rdma
%dir %{_sysconfdir}/rdma/modules
%dir %{_docdir}/%{name}
%dir %{_sysconfdir}/udev
%dir %{_sysconfdir}/udev/rules.d
%dir %{_sysconfdir}/modprobe.d
%dir %{_sysconfdir}/sysctl.d
%doc %{_docdir}/%{name}/README.md
%doc %{_docdir}/%{name}/udev.md
%config(noreplace) %{_sysconfdir}/rdma/mlx4.conf
%config(noreplace) %{_sysconfdir}/modprobe.d/mlx4.conf
%dir %{sysmodprobedir}
%{sysmodprobedir}/libmlx4.conf
%{_libexecdir}/mlx4-setup.sh
%{_libexecdir}/mlx4-set-guid.sh
%{_bindir}/ibdev2netdev
%{_bindir}/show_gids
%config(noreplace) %{_sysconfdir}/rdma/modules/infiniband.conf
%config(noreplace) %{_sysconfdir}/rdma/modules/iwarp.conf
%config(noreplace) %{_sysconfdir}/rdma/modules/opa.conf
%config(noreplace) %{_sysconfdir}/rdma/modules/rdma.conf
%if 0%{?rhel} >= 8
%config(noreplace) %{_sysconfdir}/rdma/modules/rdmaip.conf
%endif
%config(noreplace) %{_sysconfdir}/rdma/modules/roce.conf
%config(noreplace) %{_sysconfdir}/udev/rules.d/*
%config(noreplace) %{_sysconfdir}/modprobe.d/truescale.conf
%config(noreplace) %{_sysconfdir}/sysctl.d/90-rds.conf
%{_unitdir}/rdma-hw.target
%{_unitdir}/rdma-load-modules@.service
%{_unitdir}/rdma-set-guid.service
%if 0%{?rhel} >= 8
%{_unitdir}/rdmaip-load-module.service
%endif
%dir %{dracutlibdir}
%dir %{dracutlibdir}/modules.d
%dir %{dracutlibdir}/modules.d/05rdma
%{dracutlibdir}/modules.d/05rdma/module-setup.sh
%dir %{_udevrulesdir}
%{_udevrulesdir}/../rdma_rename
# Consider replacing below with {_udevrulesdir}/*
%{_udevrulesdir}/60-rdma-ndd.rules
%{_udevrulesdir}/60-rdma-set-guid.rules
%{_udevrulesdir}/60-rdma-persistent-naming.rules
%{_udevrulesdir}/75-rdma-description.rules
%{_udevrulesdir}/90-rdma-hw-modules.rules
%{_udevrulesdir}/90-rdma-ulp-modules.rules
%{_udevrulesdir}/90-rdma-umad.rules
# Consider replacing above with {_udevrulesdir}/*
# Orabug 33946678 - IPoIB: We need to configure IPoIB interfaces.
# Line below unconditionally includes network-scripts/if{up,down}-ib
# on OL7, OL8 & OL9, until NetworkManager supports pkey-ed IB interfaces
# with custom names (Ex: stibX, clibX on Exadata).
%{_sysconfdir}/sysconfig/network-scripts/*
%{_libexecdir}/truescale-serdes.cmds
%{_sbindir}/rdma-ndd
%{_unitdir}/rdma-ndd.service
%{_mandir}/man8/rdma-ndd.*
%license COPYING.*

%files devel
%defattr(-,root,root)
%doc %{_docdir}/%{name}/MAINTAINERS
%dir %{_includedir}/infiniband
%dir %{_includedir}/rdma
%{_includedir}/infiniband/*
%{_includedir}/rdma/*
%if %{with_static}
%{_libdir}/lib*.a
%endif
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/ibv_*
%{_mandir}/man3/rdma*
%{_mandir}/man3/umad*
%{_mandir}/man3/*_to_ibv_rate.*
%{_mandir}/man7/rdma_cm.*
%{_mandir}/man3/mlx5dv*
%{_mandir}/man3/mlx4dv*
%{_mandir}/man7/mlx5dv*
%{_mandir}/man7/mlx4dv*
%{_mandir}/man3/ibnd_*

%files -n ibacm
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rdma/ibacm_opts.cfg
%{_bindir}/ib_acme
%{_sbindir}/ibacm
%{_mandir}/man1/ib_acme.*
%{_mandir}/man7/ibacm.*
%{_mandir}/man7/ibacm_prov.*
%{_mandir}/man8/ibacm.*
%{_unitdir}/ibacm.service
%{_unitdir}/ibacm.socket
%dir %{_libdir}/ibacm
%{_libdir}/ibacm/*
%doc %{_docdir}/%{name}/ibacm.md

%files -n infiniband-diags
%defattr(-,root, root)
%dir %{_sysconfdir}/infiniband-diags
%config(noreplace) %{_sysconfdir}/infiniband-diags/*
%{_sbindir}/ibaddr
%{_mandir}/man8/ibaddr*
%{_sbindir}/ibnetdiscover
%{_mandir}/man8/ibnetdiscover*
%{_sbindir}/ibping
%{_mandir}/man8/ibping*
%{_sbindir}/ibportstate
%{_mandir}/man8/ibportstate*
%{_sbindir}/ibroute
%{_mandir}/man8/ibroute.*
%{_sbindir}/ibstat
%{_mandir}/man8/ibstat.*
%{_sbindir}/ibsysstat
%{_mandir}/man8/ibsysstat*
%{_sbindir}/ibtracert
%{_mandir}/man8/ibtracert*
%{_sbindir}/perfquery
%{_mandir}/man8/perfquery*
%{_sbindir}/sminfo
%{_mandir}/man8/sminfo*
%{_sbindir}/smpdump
%{_mandir}/man8/smpdump*
%{_sbindir}/smpquery
%{_mandir}/man8/smpquery*
%{_sbindir}/saquery
%{_mandir}/man8/saquery*
%{_sbindir}/vendstat
%{_mandir}/man8/vendstat*
%{_sbindir}/iblinkinfo
%{_mandir}/man8/iblinkinfo*
%{_sbindir}/ibqueryerrors
%{_mandir}/man8/ibqueryerrors*
%{_sbindir}/ibcacheedit
%{_mandir}/man8/ibcacheedit*
%{_sbindir}/ibccquery
%{_mandir}/man8/ibccquery*
%{_sbindir}/ibccconfig
%{_mandir}/man8/ibccconfig*
%{_sbindir}/dump_fts
%{_mandir}/man8/dump_fts*
%{_sbindir}/ibhosts
%{_mandir}/man8/ibhosts*
%{_sbindir}/ibswitches
%{_mandir}/man8/ibswitches*
%{_sbindir}/ibnodes
%{_mandir}/man8/ibnodes*
%{_sbindir}/ibrouters
%{_mandir}/man8/ibrouters*
%{_sbindir}/ibfindnodesusing.pl
%{_mandir}/man8/ibfindnodesusing*
%{_sbindir}/ibidsverify.pl
%{_mandir}/man8/ibidsverify*
%{_sbindir}/check_lft_balance.pl
%{_mandir}/man8/check_lft_balance*
%{_sbindir}/dump_lfts.sh
%{_mandir}/man8/dump_lfts*
%{_sbindir}/dump_mfts.sh
%{_mandir}/man8/dump_mfts*
%{_sbindir}/ibclearerrors
%{_mandir}/man8/ibclearerrors*
%{_sbindir}/ibclearcounters
%{_mandir}/man8/ibclearcounters*
%{_sbindir}/ibstatus
%{_mandir}/man8/ibstatus*
%{_mandir}/man8/infiniband-diags*
%{_libdir}/libibmad*.so.*
%{_libdir}/libibnetdisc*.so.*
%{perl_vendorlib}/IBswcountlimits.pm

%files -n infiniband-diags-compat
%defattr(-,root,root)
%{_sbindir}/ibcheckerrs
%{_mandir}/man8/ibcheckerrs*
%{_sbindir}/ibchecknet
%{_mandir}/man8/ibchecknet*
%{_sbindir}/ibchecknode
%{_mandir}/man8/ibchecknode*
%{_sbindir}/ibcheckport
%{_mandir}/man8/ibcheckport.*
%{_sbindir}/ibcheckportwidth
%{_mandir}/man8/ibcheckportwidth*
%{_sbindir}/ibcheckportstate
%{_mandir}/man8/ibcheckportstate*
%{_sbindir}/ibcheckwidth
%{_mandir}/man8/ibcheckwidth*
%{_sbindir}/ibcheckstate
%{_mandir}/man8/ibcheckstate*
%{_sbindir}/ibcheckerrors
%{_mandir}/man8/ibcheckerrors*
%{_sbindir}/ibdatacounts
%{_mandir}/man8/ibdatacounts*
%{_sbindir}/ibdatacounters
%{_mandir}/man8/ibdatacounters*
%{_sbindir}/ibdiscover.pl
%{_mandir}/man8/ibdiscover*
%{_sbindir}/ibswportwatch.pl
%{_mandir}/man8/ibswportwatch*
%{_sbindir}/ibqueryerrors.pl
%{_sbindir}/iblinkinfo.pl
%{_sbindir}/ibprintca.pl
%{_mandir}/man8/ibprintca*
%{_sbindir}/ibprintswitch.pl
%{_mandir}/man8/ibprintswitch*
%{_sbindir}/ibprintrt.pl
%{_mandir}/man8/ibprintrt*
%{_sbindir}/set_nodedesc.sh

%files -n infiniband-diags-guest
%defattr(-,root,root)
%{_sbindir}/ibstat
%{_mandir}/man8/ibstat.*
%{_sbindir}/ibstatus
%{_mandir}/man8/ibstatus.*
%{_libdir}/libibmad*.so.*
%{_libdir}/libibnetdisc*.so.*

%files -n iwpmd
%defattr(-,root,root)
%dir %{_sysconfdir}/rdma
%dir %{_sysconfdir}/rdma/modules
%{_sbindir}/iwpmd
%{_unitdir}/iwpmd.service
%config(noreplace) %{_sysconfdir}/rdma/modules/iwpmd.conf
%config(noreplace) %{_sysconfdir}/iwpmd.conf
%{_udevrulesdir}/90-iwpmd.rules
%{_mandir}/man8/iwpmd.*
%{_mandir}/man5/iwpmd.*

%files -n libibumad
%defattr(-,root,root)
%{_libdir}/libibumad*.so.*

%files -n libibverbs
%defattr(-,root,root)
%dir %{_sysconfdir}/libibverbs.d
%dir %{_libdir}/libibverbs
%{_libdir}/libibverbs*.so.*
%{_libdir}/libibverbs/*.so
%{_libdir}/libmlx5.so.*
%{_libdir}/libmlx4.so.*
%config(noreplace) %{_sysconfdir}/libibverbs.d/*.driver
%doc %{_docdir}/%{name}/libibverbs.md
%doc %{_docdir}/%{name}/rxe.md
%doc %{_docdir}/%{name}/tag_matching.md
%{_mandir}/man7/rxe*

%files -n libibverbs-utils
%defattr(-,root,root)
%{_bindir}/ibv_*
%{_mandir}/man1/ibv_*

%files -n librdmacm
%defattr(-,root,root)
%{_libdir}/librdmacm*.so.*
%dir %{_libdir}/rsocket
%{_libdir}/rsocket/*.so*
%doc %{_docdir}/%{name}/librdmacm.md
%{_mandir}/man7/rsocket.*

%files -n librdmacm-utils
%defattr(-,root,root)
%{_bindir}/cmtime
%{_bindir}/mckey
%{_bindir}/rcopy
%{_bindir}/rdma_client
%{_bindir}/rdma_server
%{_bindir}/rdma_xclient
%{_bindir}/rdma_xserver
%{_bindir}/riostream
%{_bindir}/rping
%{_bindir}/rstream
%{_bindir}/ucmatose
%{_bindir}/udaddy
%{_bindir}/udpong
%{_mandir}/man1/cmtime.*
%{_mandir}/man1/mckey.*
%{_mandir}/man1/rcopy.*
%{_mandir}/man1/rdma_client.*
%{_mandir}/man1/rdma_server.*
%{_mandir}/man1/rdma_xclient.*
%{_mandir}/man1/rdma_xserver.*
%{_mandir}/man1/riostream.*
%{_mandir}/man1/rping.*
%{_mandir}/man1/rstream.*
%{_mandir}/man1/ucmatose.*
%{_mandir}/man1/udaddy.*
%{_mandir}/man1/udpong.*

%files -n python3-pyverbs
%{python3_sitearch}/pyverbs
%dir %{_docdir}/%{name}/tests/
%{_docdir}/%{name}/tests/*.py
# On OL8 brp-python-bytecompile is not creating the pycache.
# If we want it in the future we can create it using:
# %%py_byte_compile %%{__python3} %%{buildroot}%%{_datadir}/foo/bar`
%if 0%{?rhel} == 7
%{_docdir}/%{name}/tests/__pycache__/*.pyc
%endif

%files -n srp_daemon
%defattr(-,root,root)
%dir %{_libexecdir}/srp_daemon
%dir %{_sysconfdir}/rdma
%dir %{_sysconfdir}/rdma/modules
%config(noreplace) %{_sysconfdir}/srp_daemon.conf
%config(noreplace) %{_sysconfdir}/rdma/modules/srp_daemon.conf
%{_libexecdir}/srp_daemon/start_on_all_ports
%{_unitdir}/srp_daemon.service
%{_unitdir}/srp_daemon_port@.service
%{_sbindir}/ibsrpdm
%{_sbindir}/srp_daemon
%{_sbindir}/run_srp_daemon
%{_udevrulesdir}/60-srp_daemon.rules
%{_mandir}/man5/srp_daemon.service.5*
%{_mandir}/man5/srp_daemon_port@.service.5*
%{_mandir}/man8/ibsrpdm.8*
%{_mandir}/man8/srp_daemon.8*
%doc %{_docdir}/%{name}/ibsrpdm.md

%changelog
* Thu Mar 21 2024 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.8
- libmlx5: Disable MLX5_LIB_CAP_DYN_UAR in the mlx5 provider (Mark Haywood) [Orabug: 36415718]

* Tue Jul 19 2022 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.7
- oracle: Fix syntax errors in rdma-set-guid.rules (Mark Haywood) [Orabug: 34390789]
- libmlx5: Fix Sandy Bridge test for ARM (Mark Haywood) [Orabug: 34399745]

* Thu Jul 14 2022 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.6
- libmlx5: Improve the test for Sandy Bridge processor (Mark Haywood) [Orabug: 34382145]

* Wed May 04 2022 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.5
- rdma-core.spec: Include network-scripts/if{up,down}-ib by default (Sharath Srinivasan) [Orabug 33946678]
- oracle/spec: Remove conditional packaging of rdma-set-guid.service (Mark Haywood) [Orabug 33968370]
- oracle: Do not load the RDMAIP kernel module in UEK7 and beyond (Mark Haywood) [Orabug 33679923]
- mlx5: Optimize dbrec data structure (Mark Haywood) [Orabug 33983059]
- oracle: Enable rdma-set-guid for Exadata systems (Mark Haywood) [Orabug 34091796]
- rdma-core: Move ibdev2netdev from oracle-rdma-tools to rdma-core (Mark Haywood) [Orabug 32373791]
- rdma-core: Move show_gids from oracle-rdma-tools to rdma-core (Mark Haywood) [Orabug 32373797]
- oracle/spec: Update package descriptions to align with upstream (Mark Haywood) [Orabug 34110737]
- oracle: Adjust cmake out-of-source builds setting for OL9 (Mark Haywood) [Orabug 33841055]
- oracle/doc: Add prebuilt man pages for OL9 (Mark Haywood) [Orabug 33840747]
- oracle/spec: Remove pandoc build requirement for ol9 (Mark Haywood) [Orabug 33840747]
- oracle/spec: Rebuild for OL9 (Mark Haywood) [Orabug: 33836216]

* Thu Mar 10 2022 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.4
- oracle: Provide a service to set static GUIDs for mlx4 IOV devices (Mark Haywood) [Orabug: 33761402]

* Tue Sep 14 2021 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.3
- libibmad: dont set errno for MAD "no records" err - app binary compatibility (Mark Haywood) [Orabug: 33479089]

* Tue Mar 09 2021 Mark Haywood <mark.haywood@oracle.com> - 5:34.0-1.0.2
- libibverbs(verbs,libmlx4,libmlx5, librxe): Add Shared PD (Mark Haywood) [Orabug: 21525110, 28036829, 31086119]
- libibverbs(verbs,libmlx4,libmlx5), librdmacm: Add XRC Compatibility Layer (Mark Haywood) [Orabug: 21616281, 28037506]
- libibverbs(verbs,libmlx4,libmlx5): Add Userlevel FMR (Mark Haywood) [Orabug: 21525110, 26547698]
- libibverbs: Detect uek_abi_version and UEK4 compatibility in libibverbs (Gerd Rausch) [Orabug: 28035740]
- libibverbs(libmlx4): Conditionally disable blueflame (Mark Haywood) [Orabug: 25894415]

* Tue Mar 09 2021 Aron Silverton <aron.silverton@oracle.com> - 5:34.0-1.0.1
- oracle: Package for Oracle (Mark Haywood) [Orabug: 32588075]
- oracle/spec: Remove empty directory from pyverbs (Aron Silverton) [Orabug: 32670188]
- oracle/spec: Remove base package dependency for libs & devel (Mark Haywood) [Orabug: 32674846]
- oracle/spec: Make NAME_KERNEL interface naming mode (Aron Silverton) [Orabug: 29508529]
- oracle/spec: Disable LTO (Aron Silverton) [Orabug: 32351282] 
- oracle/spec: Generate binaries with debug symbols (Aron Silverton) [Orabug: 29839092]
- oracle: Add support for named PKEY devices (Aron Silverton) [Orabug: 29636104]
- oracle/spec: Load RDS kernel modules using hot-plug (Aron Silverton) [Orabug: 28667038]
- oracle/spec: Load sysctl settings for RDS (Aron Silverton) [Orabug: 28667038]
- oracle: Disable loading ib_iser (Aron Silverton) [Orabug: 28188517]
- oracle: Disable loading NFS over RDMA (Aron Silverton) [Orabug: 28667412]
- oracle: Load RDMAIP kernel module using hot-plug (Aron Silverton) [Orabug: 28782057]
- oracle: Add buildrpm and link spec file (Aron Silverton) [Orabug: 26829960]
- oracle/spec: Set initial release number for Oracle (Mark Haywood) [Orabug: 32588075]
